
Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports Syncfusion.Windows.Forms.Grid
Imports Syncfusion.Windows.Forms




 
Public Class Form1
   Inherits System.Windows.Forms.Form
   Private panel1 As System.Windows.Forms.Panel
   
    
   Private components As System.ComponentModel.Container = Nothing
   
   
   Public Sub New()
      '
      ' Required for Windows Form Designer support
      '
      InitializeComponent()
   End Sub 'New
    
   '
   ' TODO: Add any constructor code after InitializeComponent call
   '
   
    
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub 'Dispose

#Region "Windows Form Designer generated code"
    Friend WithEvents GridAwareTextBox1 As GridAwareTextBox
    Friend WithEvents SplitterControl1 As SplitterControl
    Friend WithEvents GridControl1 As GridControl
    Friend WithEvents pnlTop As System.Windows.Forms.Panel

     
    
    Private Sub InitializeComponent()
        Me.panel1 = New System.Windows.Forms.Panel
        Me.pnlTop = New System.Windows.Forms.Panel
        Me.GridAwareTextBox1 = New Syncfusion.Windows.Forms.Grid.GridAwareTextBox
        Me.SplitterControl1 = New Syncfusion.Windows.Forms.SplitterControl
        Me.GridControl1 = New Syncfusion.Windows.Forms.Grid.GridControl
        Me.panel1.SuspendLayout()
        Me.pnlTop.SuspendLayout()
        Me.SplitterControl1.SuspendLayout()
        CType(Me.GridControl1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'panel1
        '
        Me.panel1.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.panel1.Controls.Add(Me.pnlTop)
        Me.panel1.Controls.Add(Me.SplitterControl1)
        Me.panel1.Location = New System.Drawing.Point(16, 16)
        Me.panel1.Name = "panel1"
        Me.panel1.Size = New System.Drawing.Size(584, 447)
        Me.panel1.TabIndex = 2
        '
        'pnlTop
        '
        Me.pnlTop.Controls.Add(Me.GridAwareTextBox1)
        Me.pnlTop.Dock = System.Windows.Forms.DockStyle.Top
        Me.pnlTop.Location = New System.Drawing.Point(0, 0)
        Me.pnlTop.Name = "pnlTop"
        Me.pnlTop.Size = New System.Drawing.Size(584, 20)
        Me.pnlTop.TabIndex = 4
        '
        'GridAwareTextBox1
        '
        Me.GridAwareTextBox1.DisabledBackColor = System.Drawing.SystemColors.Window
        Me.GridAwareTextBox1.Dock = System.Windows.Forms.DockStyle.Fill
        Me.GridAwareTextBox1.EnabledBackColor = System.Drawing.SystemColors.Window
        Me.GridAwareTextBox1.Location = New System.Drawing.Point(0, 0)
        Me.GridAwareTextBox1.Name = "GridAwareTextBox1"
        Me.GridAwareTextBox1.Size = New System.Drawing.Size(584, 20)
        Me.GridAwareTextBox1.TabIndex = 0
        '
        'SplitterControl1
        '
        Me.SplitterControl1.Controls.Add(Me.GridControl1)
        Me.SplitterControl1.Dock = System.Windows.Forms.DockStyle.Fill
        Me.SplitterControl1.Location = New System.Drawing.Point(0, 0)
        Me.SplitterControl1.Name = "SplitterControl1"
        Me.SplitterControl1.Size = New System.Drawing.Size(584, 447)
        Me.SplitterControl1.SplitBars = Syncfusion.Windows.Forms.DynamicSplitBars.Both
        Me.SplitterControl1.TabIndex = 1
        Me.SplitterControl1.Text = "SplitterControl1"
        Me.SplitterControl1.ThemesEnabled = True
        '
        'GridControl1
        '
        Me.GridControl1.FillSplitterPane = True
        Me.GridControl1.Location = New System.Drawing.Point(0, 0)
        Me.GridControl1.Name = "GridControl1"
        Me.GridControl1.RowCount = 30
        Me.GridControl1.Size = New System.Drawing.Size(564, 427)
        Me.GridControl1.SmartSizeBox = False
        Me.GridControl1.Text = "GridControl1"
        Me.GridControl1.ThemesEnabled = True
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(616, 477)
        Me.Controls.Add(Me.panel1)
        Me.Name = "Form1"
        Me.Text = "Formula Range Selections Sample"
        Me.panel1.ResumeLayout(False)
        Me.pnlTop.ResumeLayout(False)
        Me.SplitterControl1.ResumeLayout(False)
        CType(Me.GridControl1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub 'InitializeComponent 
#End Region



    <STAThread()> _
    Shared Sub Main()
        Application.Run(New Form1())
    End Sub 'Main


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'wire the grid to the textbox
        Me.GridAwareTextBox1.WireGrid(Me.GridControl1)

        'Excel properties if wanted
        Me.GridControl1.ExcelLikeCurrentCell = True
        Me.GridControl1.ExcelLikeSelectionFrame = True
        Me.GridControl1.ShouldSynchronizeCurrentCell = True

        'make enter key move down
        Me.GridControl1.EnterKeyBehavior = GridDirectionType.Down

        'make the whole table handle formulas
        'this.gridControl1.TableStyle.CellType = "FormulaCell";
        'or
        'set column 2 to hold formulas
        Dim style As GridStyleInfo = Me.GridControl1.ColStyles(2)
        style.CellType = "FormulaCell"
        style.BackColor = Color.LightGoldenrodYellow
        Me.GridControl1.ColWidths(2) = 100

        'set column 3 to hold formulas
        style = Me.GridControl1.ColStyles(3)
        style.CellType = "FormulaCell"
        style.BackColor = Color.LightGoldenrodYellow
        Me.GridControl1.ColWidths(3) = 100

        'add the mousecontroller that handles formularange selections
        Dim formulaController As New FormulaRangeSelectionController(GridControl1)
        GridControl1.MouseControllerDispatcher.Add(formulaController)

        'if you want the user to have to hold down control before a 
        'drag is started, then uncomment this line
        'formulaController.MouseRequiresControlKey = true;
        'if you want the user to have to hold down control in order
        'to start a drag with the arrow keys, then uncomment this line
        'formulaController.KeyBoardRequiresControlKey = true;
        'turn off ole D&D
        'this.gridControl1.ControllerOptions = GridControllerOptions.All & (~GridControllerOptions.OleDataSource);
        'set cell 1,1 current
        Me.GridControl1.ForceCurrentCellMoveTo = True 'required to get the move to take in FormLoad
        Me.GridControl1.CurrentCell.MoveTo(1, 1)

        'put some random values in column 1
        Dim r As New Random()
        Dim row As Integer

        For row = 1 To Me.GridControl1.RowCount
            Me.GridControl1(row, 1).CellValue = r.Next(1000)
        Next
    End Sub 'Form1_Load


#Region "splitter event handlers - required"

    'When a new splitter pane is created, a new GridControl is created. So, this new control
    'needs to be wired as the original control was.
    Private Sub splitterControl1_PaneCreated(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.SplitterPaneEventArgs) Handles SplitterControl1.PaneCreated
        Dim grid As GridControlBase = CType(e.Control, GridControlBase)
        Me.GridAwareTextBox1.WireGrid(grid)

        Dim formulaController As New FormulaRangeSelectionController(grid)
        grid.MouseControllerDispatcher.Add(formulaController)
    End Sub 'splitterControl1_PaneCreated


    'When the pane goes away, the dynamically created GridControl goes away as well, so we
    'need to unwire things...
    Private Sub splitterControl1_PaneClosing(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.SplitterPaneEventArgs) Handles SplitterControl1.PaneClosing
        Dim grid As GridControlBase = CType(e.Control, GridControlBase)
        Me.GridAwareTextBox1.UnwireGrid(grid)
    End Sub 'splitterControl1_PaneClosing

#End Region
End Class 'Form1 